ag-Grid Vue Component
==============

This project contains the Vue Component for use with ag-Grid

#### Install with Bower
```sh
$ bower install ag-grid-vue
```

#### Install with npm
```sh
$ npm install ag-grid-vue
```

See [www.ag-grid.com](http://www.ag-grid.com) for an overview and full documentation.

Frameworks Supported
====================
Framework specific Getting Started guides:
[Angular 1](https://www.ag-grid.com/best-angularjs-data-grid/) | [Angular 2](https://www.ag-grid.com/best-angular-2-data-grid/) | [Aurelia](https://www.ag-grid.com/best-aurelia-data-grid/)
[Javascript](https://www.ag-grid.com/best-javascript-data-grid/) | [React](https://www.ag-grid.com/best-react-data-grid/) | [TypeScript](https://www.ag-grid.com/ag-grid-typescript-webpack-2/)
[VueJS](https://www.ag-grid.com/best-vuejs-data-grid/) | [Web Components](https://www.ag-grid.com/best-web-component-data-grid/)

#### To Build
- `npm install gulp -g`
- `npm install npm-install-peers -g`
- `npm install`
- `npm-install-peers`
- `gulp`

## Examples

See the [https://github.com/ag-grid/ag-grid-vue-example](https://github.com/ag-grid/ag-grid-vue-example) for full 
working examples of what you can do with ag-Grid and VueJS Components.

Examples included are:

## Rich Grid with Pure JavaScript
![Rich Grid with Pure JavaScript](https://github.com/ag-grid/ag-grid-vue-example/blob/master/docs/images/rich-grid.png?raw=true "Rich Grid with Pure JavaScript")
## Using Dynamic Components
![Using Dynamic Components](https://github.com/ag-grid/ag-grid-vue-example/blob/master/docs/images/dynamic.png?raw=true "Using Dynamic Components")
## Using Dynamic Components - Richer Example
![Using Dynamic Components - Richer Example](https://github.com/ag-grid/ag-grid-vue-example/blob/master/docs/images/rich-dynamic.png?raw=true "Using Dynamic Components - Richer Example")
## Using Cell Editor Components
![Using Cell Editor Components](https://github.com/ag-grid/ag-grid-vue-example/blob/master/docs/images/editor.png?raw=true "Using Cell Editor Components")
## Using Pinned Row Renderers
![Using Pinned Row Renderers](https://github.com/ag-grid/ag-grid-vue-example/blob/master/docs/images/floating-row.png?raw=true "Using Pinned Row Renderers")
## Using Full Width Renderers
![Using Full Width Renderers](https://github.com/ag-grid/ag-grid-vue-example/blob/master/docs/images/full-width.png?raw=true "Using Full Width Renderers")
## Using Group Row Renderers
![Using Group Row Renderers](https://github.com/ag-grid/ag-grid-vue-example/blob/master/docs/images/grouped-row.png?raw=true "Using Group Row Renderers")
## With Filters Components
![With Filters Components](https://github.com/ag-grid/ag-grid-vue-example/blob/master/docs/images/filter.png?raw=true "With Filters Components")
## Master Detail Example
![Master Detail Example](https://github.com/ag-grid/ag-grid-vue-example/blob/master/docs/images/master-detail.png?raw=true "Master Detail Example")